%define debug_package %{nil}
%define _unpackaged_files_terminate_build 0
%define _missing_doc_files_terminate_build 0

Name: xen
Version: 4.1.2
Release: 18%{?dist}.35
Summary: Xen is a virtual machine monitor
Group: Development/Libraries
License: GPL
URL: http://xen.org/
# 
Source0: xen-4.1-23201-ovs.tar.gz
Source1: qemu-e073e694.tar.gz
Source2: ipxe-v1.0.0.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

#Patch1: dummy-null.patch
Patch2: ovs-xen-add-qos-support.patch
Patch3: ovs-xen-add-domain-running-lock-callout-hook.patch
Patch4: ovs-xen-add-long-cmdline-support.patch
Patch5: put-xenstored-tdb-to-tmpfs.patch
Patch6: load-backend-modules-at-xend-start.patch
Patch7: ovs-xen-disable-network-script.patch
Patch8: ovs-xen-xend-config-enable-ssl-relocation-server.patch
Patch9: ovs-xen-xend-config-set-vnc-listen-everywhere.patch
Patch10: ovs-xen-expose-host-uuid.patch
Patch11: acpi_timer_override_workarounds.patch
Patch12: ovs-xen-pygrub-ext4-support.patch
Patch13: ovs-xen-xend-service-status-report.patch
Patch14: ovs-backward-compatibility-with-2.x.patch
Patch15: hvmloader-acpi-s3-s4.patch
Patch16: xend-acpi-s3-s4-config.patch
Patch17: xend-acpi-s3-s4-config-code-clean-up.patch
Patch18: modprobe_gntdev.patch
Patch19: ovs-xen-tools-dom0-min-mem-disable-ballooning.patch
Patch20: gntdev-creation-udev-rule.patch
Patch21: xen-xend-service-stop-status.patch
Patch22: vif-mtu.patch
Patch23: x86_64-fix-error-checking-in-arch_set_info_guest.patch
Patch24: version-includes-OVM.patch
Patch25: patch2452.patch_14233
Patch26: change-param-of-ovs-agent-dlm.patch_6476
Patch27: fix-dom0-ballooning-when-dom-min-mem-set.patch
Patch28: xen-xend-domains-lock-path.patch
Patch29: non-ssl-vnc-localhost-only.patch
Patch30: xendomains-shutdown-vm-on-stop.patch
Patch31: xen-hotplug-script-block-share-list.patch
Patch32: xen-pygrub-fix-solaris-kernel-sniff.patch
Patch33: fix-solaris-detection.patch
Patch34: cpufreq-make-performance-default.patch
Patch35: minor-2.6.39-fixes.patch
Patch36: ovs-xen-dm-nfs-block-setup.patch
Patch37: ple-test.patch
Patch38: s3_s5_size_change.patch
Patch39: guest-reboot.patch
Patch40: rev2941.patch
Patch41: vif-mtu.patch_2524
Patch42: versioning_xen23263_qemu3cf61880.patch
Patch43: fix-tap-mtu.patch
Patch44: silence-MAP_PIRQ_TYPE_MSI_SEG.patch
Patch45: xend-stop-retun-code.patch
Patch46: xen-make_dom0_mem_augment_the_nr_pages.patch
Patch47: xen-41-enable_VCPUOP_register_vcpu_info_op_in_hvm_hypercall.patch
Patch48: xen-41-enable_VCPUOP_register_vcpu_info_op_in_hvm_hypercall-compat.patch
Patch49: revert-xen-unstable-cs-22315.patch
Patch50: xen-set-max-cstate-to-1.patch
Patch51: xen-block-create-loop-dev.patch
Patch52: xen-remove-unecessary-balloon-retries-on-vm-create-4.1.patch
Patch53: xsa7-xsa8-xen-4.1.patch
Patch54: xsa9-xen-4.1.patch
Patch55: ovs-xen-4.1-restore-1.patch
Patch56: fix-hotplug-locking.patch
Patch57: fix-hotplug-locking-using-flock.patch
Patch58: rev3283.patch
Patch59: xsa10-4.x.patch
Patch60: xsa11-4.1.patch
Patch61: xen-prevent-a-64-bit-guest-setting-reserved-bits-in-DR7.patch
Patch62: xsa13-xen-4.1.patch
Patch63: xsa14-xen-3.4-and-4.x.patch
Patch64: xsa16-xen-4.1.patch
Patch65: xsa17-qemu-xen-traditional-all.patch
Patch66: xen-xm-create-vcpu-avail-exceeds-xmlrpc-limits.patch
Patch67: xsa19-qemu-all.patch
Patch68: xen-xend-always-release-vm-running-lock.patch
Patch69: correct-rtc-hvm.patch
Patch70: xsa20.patch
Patch71: xsa21.patch
Patch72: xsa22-4.1.patch
Patch73: xsa23-4.0-4.1.patch
Patch74: xsa24.patch
Patch75: xsa25-4.1.patch
Patch76: xsa26-4.1.patch
Patch77: xsa27-4.1.patch
Patch78: xsa28-4.1.patch
Patch79: xsa29-4.1.patch
Patch80: xsa31-4.1.patch
Patch81: xsa31-4.1.revert.patch
Patch82: xsa30-4.1.patch
Patch83: xsa31-4.1.patch_4252
Patch84: xsa30-4.1-version3.patch
Patch85: ovs-xen-re-write-file.patch
Patch86: xsa33.patch
# End Oracle Patches

BuildRequires: transfig libidn-devel zlib-devel curl-devel
BuildRequires: python-devel ghostscript tetex-latex gettext
BuildRequires: ncurses-devel libaio-devel libxml2-devel
BuildRequires: flex bison pciutils-devel
# for the docs 
BuildRequires: perl 
# so that the makefile knows to install udev rules
BuildRequires: udev 
BuildRequires: texi2html imake
# need this level for modprobe --dump-modversions
BuildRequires: module-init-tools >= 3.3-0.pre3.1.16
# for the VMX "bios" 
BuildRequires: dev86

# for 3rd party builds comment this line out and provide /usr/local/bin/iasl
BuildRequires: iasl_non_redistributable
# get the source from here: http://acpica.org/downloads/

Requires: bridge-utils
Requires: udev >= 059
Requires: ovs-utils
Requires: util-linux >= 2.13-0.45

# Not strictly a dependency, but kpartx is by far the most useful tool right
# now for accessing domU data from within a dom0 so bring it in when the user
# installs xen.
Requires: kpartx
Prereq: chkconfig
Obsoletes: xen-64
#ExclusiveArch: x86_64

%description
This package contains the Xen hypervisor and Xen tools, needed to
run virtual machines on x86 systems.

%package tools
Summary: Various tooling for the manipulation of Xen instances
Group: System Environment/Libraries
Requires(pre): /sbin/ldconfig 
Requires(post): /sbin/ldconfig

%description tools
This package contains the user utilities required for the manipulation
of Xen guest instances, associated documentation and keymaps.

%package debugger
Summary:  Xen is a virtual machine monitor
Group:    Development/Libraries
Requires: xen-tools = %{version}-%{release}

%description debugger
This package contains xen debuggers, kdb and gdbsx, that can be used to
debug hypervisor, dom0, and running 32-bit and 64-bit guests.

%package devel
Summary: Development libraries for Xen tools
Group: Development/Libraries
Requires: xen-tools = %{version}-%{release}
Requires(pre): /sbin/ldconfig
Requires(post): /sbin/ldconfig

%description devel
This package contains headers and static libraries to develop applications to
manage Xen virtual machines. 

%package pvhvm-devel
Summary: Development libraries for Xen PV-HVM drivers
Group: Development/Libraries

%description pvhvm-devel
This package contains the sources necessary to build paravirtualized drivers
for linux hvm domains.  These come from the unmodified_drivers/linux-2.6
directory in the source tree.

%prep
%setup -q -n xen-4.1-23201-ovs -a 1 -a 2

%patch2 -p0
%patch3 -p0
%patch4 -p0
%patch5 -p0
%patch6 -p0
%patch7 -p0
%patch8 -p0
%patch9 -p0
%patch10 -p0
%patch11 -p0
%patch12 -p0
%patch13 -p0
%patch14 -p0
%patch15 -p0
%patch16 -p0
%patch17 -p0
%patch18 -p0
%patch19 -p0
%patch20 -p0
%patch21 -p0
%patch22 -p0
%patch23 -p0
%patch24 -p0
%patch25 -p0
%patch26 -p0
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
%patch31 -p0
%patch32 -p0
%patch33 -p0
%patch34 -p0
%patch35 -p1
%patch36 -p0
%patch37 -p0
%patch38 -p0
%patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0
%patch51 -p0
%patch52 -p0
%patch53 -p0
%patch54 -p0
%patch55 -p0
%patch56 -p0
%patch57 -p0
%patch58 -p0
%patch59 -p0
%patch60 -p0
%patch61 -p0
%patch62 -p0
%patch63 -p0
%patch64 -p0
%patch65 -p0
%patch66 -p0
%patch67 -p0
%patch68 -p0
%patch69 -p0
%patch70 -p0
%patch71 -p0
%patch72 -p0
%patch73 -p0
%patch74 -p0
%patch75 -p0
%patch76 -p0
%patch77 -p0
%patch78 -p0
%patch79 -p0
%patch80 -p0
%patch81 -p0
%patch82 -p0
%patch83 -p0
%patch84 -p0
%patch85 -p0
%patch86 -p0

# Our auto patch generation will remove execute permissions, so chmod here.
%build
#make DESTDIR=$RPM_BUILD_ROOT kdb=y install-xen install-tools install-docs
#make DESTDIR=$RPM_BUILD_ROOT clean
make max_phys_cpus=160 DESTDIR=$RPM_BUILD_ROOT install-xen install-tools

%install
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/xend-db/vnet
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/%{name}/xend-db/migrate
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/lib/xenstored
mkdir -p $RPM_BUILD_ROOT/%{_localstatedir}/run/xenstored
mkdir -p $RPM_BUILD_ROOT/%{_datadir}/doc/xen

rm -rf $RPM_BUILD_ROOT/%{_datadir}/doc/qemu
rm -rf $RPM_BUILD_ROOT/%{_sysconfdir}/hotplug

# install all of the public headers
mkdir -p $RPM_BUILD_ROOT%{_includedir}/xen/io $RPM_BUILD_ROOT%{_includedir}/xen/hvm
install -m 644 xen/include/public/io/*.h $RPM_BUILD_ROOT%{_includedir}/xen/io
install -m 644 xen/include/public/hvm/*.h $RPM_BUILD_ROOT%{_includedir}/xen/hvm
install -m 644 xen/include/public/*.h $RPM_BUILD_ROOT%{_includedir}/xen/
install -m 644 xen/include/public/COPYING $RPM_BUILD_ROOT%{_includedir}/xen/
#install -m 644 xen/kdb/README %{buildroot}%{_datadir}/doc/xen/README.kdb
#install -m 644 tools/debugger/gdbsx/README %{buildroot}%{_datadir}/doc/xen/README.gdbsx
#install -m 644 tools/perf/xmstat/README %{buildroot}%{_datadir}/doc/xen/README.xmstat

# install pvhvm headers and sources
mkdir -p $RPM_BUILD_ROOT/usr/src/xen-pvhvm-devel/%{version}-%{release}-%{_target_cpu}
cp -LpR unmodified_drivers/ $RPM_BUILD_ROOT/usr/src/xen-pvhvm-devel/%{version}-%{release}-%{_target_cpu}/

# fixing start-script dir - no longer needed
#rm -rf $RPM_BUILD_ROOT/etc/rc.d
#mkdir -p $RPM_BUILD_ROOT/etc/rc.d
#mv -f $RPM_BUILD_ROOT/etc/init.d $RPM_BUILD_ROOT/etc/rc.d/

#mv -f $RPM_BUILD_ROOT/etc/udev/xen-backend.rules $RPM_BUILD_ROOT/etc/udev/rules.d/

# remove docs
rm -fr %{buildroot}/%{_datadir}/doc/xen/

# create dirs in /var/run so that selinux contexts are right (#195952)
mkdir -p $RPM_BUILD_ROOT/var/run/xend $RPM_BUILD_ROOT/var/log/xen
mkdir -p $RPM_BUILD_ROOT/var/lib/xen/images

%post
/sbin/chkconfig --add xencommons
/sbin/chkconfig --add xend
/sbin/chkconfig --add xendomains

%preun
if [ $1 = 0 ]; then
  /sbin/chkconfig --del xencommons
  /sbin/chkconfig --del xend
  /sbin/chkconfig --del xendomains
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/boot/*

%files tools
%doc COPYING README
%doc docs/pdf/
%doc docs/misc/
%config(noreplace) %{_sysconfdir}/%{name}/
%config(noreplace) %{_sysconfdir}/sysconfig/xencommons
%config(noreplace) %{_sysconfdir}/sysconfig/xendomains
%{_sbindir}/*
%{_bindir}/*
%{_libdir}/%{name}
%{_libdir}/fs/*/*.so
%{_libdir}/*.so.*
%{_libdir}/*.so
%{_mandir}/man?/*
/usr/share/xen/man/man1/qemu-img.1
/usr/share/xen/man/man1/qemu.1
/usr/share/xen/man/man8/qemu-nbd.8
/usr/share/xen/qemu/bamboo.dtb
%{_libdir}/python*/site-packages
/usr/lib/xen/boot/hvmloader
/usr/lib/xen/bin/qemu-dm
%{_libdir}/xen/boot/hvmloader
%{_libdir}/xen/bin/qemu-dm
/usr/share/xen/create.dtd
%dir %attr(0700,root,root) %{_sysconfdir}/%{name}
%dir %{_datadir}/%{name}/qemu
%dir %{_localstatedir}/xen/dump
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/xenstored
%dir %{_localstatedir}/run/xenstored
%dir %{_localstatedir}/run/xend
%dir %attr(0700,root,root) /var/log/xen
%{_datadir}/%{name}/qemu/keymaps/*
%{_datadir}/%{name}/qemu/*.bin
%{_datadir}/%{name}/qemu/*.x
%{_datadir}/%{name}/qemu/openbios*
%{_sysconfdir}/rc.d/init.d/*
#%{_sysconfdir}/udev/xend.rules
%{_sysconfdir}/udev/rules.d/*.rules
%{_localstatedir}/lib/%{name}/*
#/usr/share/doc/xen/README.xmstat

%files debugger
%{_sbindir}/gdbsx
#/usr/share/doc/xen/README.kdb
#/usr/share/doc/xen/README.gdbsx

%files devel
%defattr(-,root,root)
%{_includedir}/
%{_libdir}/*.a

%files pvhvm-devel
%defattr(-,root,root)
/usr/src/xen-pvhvm-devel/*

%changelog
* Thu Jan 03 2013 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.35 
- VT-d: fix interrupt remapping source validation for devices behind legacy bridges
  Using SVT_VERIFY_BUS here doesn't make sense; native Linux also
  uses SVT_VERIFY_SID_SQ here instead.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Signed-off-by: Todd Vierling <todd.vierling@oracle.com> [bug 15997514] {CVE-2012-5634} 

* Tue Dec 25 2012 Chuang Cao <chuang.cao@oracle.com> - 4.1.2-18.el5.34 
- When xend re-writes the files which store domains' information and if the file is empty , do things like file does not exist
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Signed-off-by: Chuang Cao <chuang.cao@oracle.com>
  Backported-by: Chuang Cao <chuang.cao@oracle.com> [bug 15919504]  

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.33 
- xen: fix error handling of guest_physmap_mark_populate_on_demand()
  The only user of the "out" label bypasses a necessary unlock, thus
  enabling the caller to lock up Xen.
  Also, the function was never meant to be called by a guest for itself,
  so rather than inspecting the code paths in depth for potential other
  problems this might cause, and adjusting e.g. the non-guest printk()
  in the above error path, just disallow the guest access to it.
  Finally, the printk() (considering its potential of spamming the log,
  the more that it's not using XENLOG_GUEST), is being converted to
  P2M_DEBUG(), as debugging is what it apparently was added for in the
  first place.
  This is XSA-30 / CVE-2012-5514.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: George Dunlap <george.dunlap@eu.citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Joe Jin <joe.jin@oracle.com> [bug 15906282] {CVE-2012-5514} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.32 
- memop: limit guest specified extent order
  Allowing unbounded order values here causes almost unbounded loops
  and/or partially incomplete requests, particularly in PoD code.
  The added range checks in populate_physmap(), decrease_reservation(),
  and the "in" one in memory_exchange() architecturally all could use
  PADDR_BITS - PAGE_SHIFT, and are being artificially constrained to
  MAX_ORDER.
  This is XSA-31 / CVE-2012-5515.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Chuck Anderson <joe.jin@oracle.com> [bug 15906297] {CVE-2012-5515} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.31 
- xen: fix error path of guest_physmap_mark_populate_on_demand()
  The only user of the "out" label bypasses a necessary unlock, thus
  enabling the caller to lock up Xen.
  This is XSA-30 / CVE-2012-5514.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Joe Jin <joe.jin@oracle.com> [bug 15906282] {CVE-2012-5514} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.30 
- Revert xsa31-4.1.patch.  It had both XSA-30 and XSA-31
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 15906297]  

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.29 
- memop: limit guest specified extent order
  Allowing unbounded order values here causes almost unbounded loops
  and/or partially incomplete requests, particularly in PoD code.
  The added range checks in populate_physmap(), decrease_reservation(),
  and the "in" one in memory_exchange() architecturally all could use
  PADDR_BITS - PAGE_SHIFT, and are being artificially constrained to
  MAX_ORDER.
  This is XSA-31 / CVE-2012-5515.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewd-by: Joe Jin <joe.jin@oracle.com> [bug 15906297] {CVE-2012-5515} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.28 
- xen: add missing guest address range checks to XENMEM_exchange handlers
  Ever since its existence (3.0.3 iirc) the handler for this has been
  using non address range checking guest memory accessors (i.e.
  the ones prefixed with two underscores) without first range
  checking the accessed space (via guest_handle_okay()), allowing
  a guest to access and overwrite hypervisor memory.
  This is XSA-29 / CVE-2012-5513.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Joe Jin <joe.jin@oracle.com> [bug 15906265] {CVE-2012-5513} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.27 
- x86/HVM: range check xen_hvm_set_mem_access.hvmmem_access before use
  Otherwise an out of bounds array access can happen if changing the
  default access is being requested, which - if it doesn't crash Xen -
  would subsequently allow reading arbitrary memory through
  HVMOP_get_mem_access (again, unless that operation crashes Xen).
  This is XSA-28 / CVE-2012-5512.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Tim Deegan <tim@xen.org>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-off-by: Joe Jin <joe.jin@oracle.com> [bug 15906254] {CVE-2012-5512} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.26 
- hvm: Limit the size of large HVM op batches
  Doing large p2m updates for HVMOP_track_dirty_vram without preemption
  ties up the physical processor. Integrating preemption into the p2m
  updates is hard so simply limit to 1GB which is sufficient for a 15000
  * 15000 * 32bpp framebuffer.
  For HVMOP_modified_memory and HVMOP_set_mem_type preemptible add the
  necessary machinery to handle preemption.
  This is CVE-2012-5511 / XSA-27.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  x86/paging: Don't allocate user-controlled amounts of stack memory.
  This is XSA-27 / CVE-2012-5511.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  v2: Provide definition of GB to fix x86-32 compile.
  Signed-off-by: Jan Beulich <JBeulich@suse.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: Joe Jin <joe.jin@oracle.com> [bug 15906193] {CVE-2012-5511} 

* Sun Dec 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.25 
- gnttab: fix releasing of memory upon switches between versions
  gnttab_unpopulate_status_frames() incompletely freed the pages
  previously used as status frame in that they did not get removed from
  the domain's xenpage_list, thus causing subsequent list corruption
  when those pages did get allocated again for the same or another purpose.
  Similarly, grant_table_create() and gnttab_grow_table() both improperly
  clean up in the event of an error - pages already shared with the guest
  can't be freed by just passing them to free_xenheap_page(). Fix this by
  sharing the pages only after all allocations succeeded.
  This is CVE-2012-5510 / XSA-26.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 15906178] {CVE-2012-5510} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.24 
- libxc: builder: limit maximum size of kernel/ramdisk.
  Allowing user supplied kernels of arbitrary sizes, especially during
  decompression, can swallow up dom0 memory leading to either virtual
  address space exhaustion in the builder process or allocation
  failures/OOM killing of both toolstack and unrelated processes.
  We disable these checks when building in a stub domain for pvgrub
  since this uses the guest's own memory and is isolated.
  Decompression of gzip compressed kernels and ramdisks has been safe
  since 14954:58205257517d (Xen 3.1.0 onwards).
  This is XSA-25 / CVE-2012-4544.
  Also make explicit checks for buffer overflows in various
  decompression routines. These were already ruled out due to other
  properties of the code but check them as a belt-and-braces measure.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  [ Includes 25589:60f09d1ab1fe for CVE-2012-2625 ]
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 14812640] {CVE-2012-4544} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.23 
- compat/gnttab: Prevent infinite loop in compat code
  c/s 20281:95ea2052b41b, which introduces Grant Table version 2
  hypercalls introduces a vulnerability whereby the compat hypercall
  handler can fall into an infinite loop.
  If the watchdog is enabled, Xen will die after the timeout.
  This is a security problem, XSA-24 / CVE-2012-4539.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 14809075] {CVE-2012-4539} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.22 
- xen/mm/shadow: check toplevel pagetables are present before unhooking them.
  If the guest has not fully populated its top-level PAE entries when it calls
  HVMOP_pagetable_dying, the shadow code could try to unhook entries from
  MFN 0.  Add a check to avoid that case.
  This issue was introduced by c/s 21239:b9d2db109cf5.
  This is a security problem, XSA-23 / CVE-2012-4538.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Tested-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 14809055] {CVE-2012-4538} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.21 
- x86/physmap: Prevent incorrect updates of m2p mappings
  In certain conditions, such as low memory, set_p2m_entry() can fail.
  Currently, the p2m and m2p tables will get out of sync because we still
  update the m2p table after the p2m update has failed.
  If that happens, subsequent guest-invoked memory operations can cause
  BUG()s and ASSERT()s to kill Xen.
  This is fixed by only updating the m2p table iff the p2m was
  successfully updated.
  This is a security problem, XSA-22 / CVE-2012-4537.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Acked-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 14809010] {CVE-2012-4537} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.20 
- x86/physdev: Range check pirq parameter from guests
  Otherwise Xen will read beyond either end of the struct
  domain.arch.pirq_emuirq array, usually resulting in a fatal page fault.
  This vulnerability was introduced by c/s 23241:d21100f1d00e, which adds
  a call to domain_pirq_to_emuirq() which uses the guest provided pirq
  value before range checking it, and was fixed by c/s 23573:584c2e5e03d9
  which changed the behaviour of the domain_pirq_to_emuirq() macro to use
  radix trees instead of a flat array.
  This is XSA-21 / CVE-2012-4536.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com>
  Reviewed-by: John Haxby <john.haxby@oracle.com> [bug 14808999] {CVE-2012-4536} 

* Thu Nov 08 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.19 
- VCPU/timers: Prevent overflow in calculations, leading to DoS vulnerability
  The timer action for a vcpu periodic timer is to calculate the next
  expiry time, and to reinsert itself into the timer queue.  If the
  deadline ends up in the past, Xen never leaves __do_softirq().  The
  affected PCPU will stay in an infinite loop until Xen is killed by the
  watchdog (if enabled).
  This is a security problem, XSA-20 / CVE-2012-4535.
  Signed-off-by: Andrew Cooper <andrew.cooper3@citrix.com>
  Acked-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14808914] {CVE-2012-4535} 

* Wed Nov 07 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.18 
- Correct RTC time offset update error for HVM guest
  changeset 24947:b198ada9689d
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 15846562]  

* Tue Oct 23 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.17 
- always release vm running lock on VM shutdown
  Before this patch, when xend restarted, the VM running lock will not be released
  on shutdown, so the VM could never start again.
  Talked with Junjie, we recommend always releasing the lock on VM shutdown. So
  even when xend restarted, there should be no stale lock leaving there.
  Backported-by: Joe Jin <joe.jin@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 14799467]  

* Tue Sep 11 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.16 
- Xen Security Advisory CVE-2012-4411 / XSA-19
  version 2
  guest administrator can access qemu monitor console
  Disable qemu monitor by default.  The qemu monitor is an overly
  powerful feature which must be protected from untrusted (guest)
  administrators.
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14612320] {CVE-2012-4411} 

* Thu Aug 30 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.15 
- fix xm create vcpu_avail exceeds XMLRPC int limits
  If maxvcpus = vcpus = 40, (1<<40 -1) will exceed XMLRPC int limit. Change it to
  str will work. Then in the xend side, it will converted back to int.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 14483583] {CVE-2012-3515} 

* Wed Aug 29 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.14 
- console: bounds check whenever changing the cursor due to an escape code
  The device model used by fully virtualised (HVM) domains, qemu, does
  not properly handle escape VT100 sequences when emulating certain
  devices with a virtual console backend.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14555087] {CVE-2012-3515} 

* Wed Aug 29 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.13 
- x86/pvhvm: properly range-check PHYSDEVOP_map_pirq/MAP_PIRQ_TYPE_GSI
  PHYSDEVOP_map_pirq with MAP_PIRQ_TYPE_GSI does not range check
  map->index.
  This is being used as a array index, and hence must be validated before
  use.
  A malicious HVM guest kernel can crash the host.  It might also be
  able to read hypervisor or guest memory.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14555053] {CVE-2012-3496} 

* Wed Aug 29 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.12 
- xen: Don't BUG_ON() PoD operations on a non-translated guest.
  XENMEM_populate_physmap can be called with invalid flags.  By calling
  it with MEMF_populate_on_demand flag set, a BUG can be triggered if a
  translating paging mode is not being used.
  Signed-off-by: Tim Deegan <tim@xen.org>
  Reviewed-by: Ian Campbell <ian.campbell@citrix.com>
  Tested-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14555002] {CVE-2012-3496} 

* Wed Aug 29 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.11 
- xen: handle out-of-pirq condition correctly in PHYSDEVOP_get_free_pirq
  PHYSDEVOP_get_free_pirq does not check that its call to get_free_pirq
  succeeded, and if it fails will use the error code as an array index.
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Jan Beulich <JBeulich@suse.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14554982] {CVE-2012-3495} 

* Wed Aug 29 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.10 
- xen: prevent a 64 bit guest setting reserved bits in DR7
  The upper 32 bits of this register are reserved and should be written as zero.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Reviewed-by: Ian Campbell <ian.campbell@citrix.com>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14554864] {CVE-2012-3494} 

* Thu Aug 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.9 
- Xen Security Advisory CVE-2012-3433 / XSA-11
  HVM guest destroy p2m teardown host DoS vulnerability
  An HVM guest is able to manipulate its physical address space such
  that tearing down the guest takes an extended period amount of
  time searching for shared pages.
  This causes the domain 0 VCPU which tears down the domain to be
  blocked in the destroy hypercall. This causes that domain 0 VCPU to
  become unavailable and may cause the domain 0 kernel to panic.
  There is no requirement for memory sharing to be in use.
  From the patch description:
  xen: only check for shared pages while any exist on teardown
  Avoids worst case behavour when guest has a large p2m.
  This is XSA-11 / CVE-2012-nnn
  Signed-off-by: Tim Deegan <tim@xen.org>
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Tested-by: Olaf Hering <olaf@aepfle.de>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14390433] 

* Thu Aug 02 2012 Chuck Anderson <chuck.anderson@oracle.com> - 4.1.2-18.el5.8 
- Xen Security Advisory XSA-10
  HVM guest user mode MMIO emulation DoS vulnerability
  ISSUE DESCRIPTION
  =================
  Internal data of the emulator for MMIO operations may, under
  certain rare conditions, at the end of one emulation cycle be left
  in a state affecting a subsequent emulation such that this second
  emulation would fail, causing an exception to be reported to the
  guest kernel where none is expected.
  NOTE: No CVE number!
  The patch description is as follow:
  x86/hvm: don't leave emulator in inconsistent state
  The fact that handle_mmio(), and thus the instruction emulator, is
  being run through twice for emulations that require involvement of the
  device model, allows for the second run to see a different guest state
  than the first one. Since only the MMIO-specific emulation routines
  update the vCPU's io_state, if they get invoked on the second pass,
  internal state (and particularly this variable) can be left in a state
  making successful emulation of a subsequent MMIO operation impossible.
  Consequently, whenever the emulator invocation returns without
  requesting a retry of the guest instruction, reset io_state.
  Signed-off-by: Jan Beulich <jbeulich@suse.com>
  Acked-by: Keir Fraser <keir@xen.org>
  Signed-off-by: Chuck Anderson <chuck.anderson@oracle.com> [bug 14390419] 

* Fri Jul 20 2012 Dave McCracken <dave.mccracken@oracle.com> - 4.1.2-18.el5.7 
- Add "allowhugepage" flag as a synonym for "allowsuperpage"
  for compatibility with previous releases.
  Signed-off-by: Dave McCracken <dave.mccracken@oracle.com>
  Acked-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  Acked-by: Adnan Misherfi <adnan.misherfi@oracle.com> [bug 13821795] 

* Tue Jun 19 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.6 
- fix hotplug script locking using flock
  We already has a fix there, but this one is better:
  1. No timeout: in the old one, if one process holding the lock more than 100
  seconds, other processes could steal it.
  2. No leftovers: if a process holding this lock is dead, it will close the lock
  file, so it will not affect other processes.
  This patch is from OL5U8 Red Hat xen.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 14216774] 

* Tue Jun 19 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.5 
- tools/hotplug: fix locking
  The current locking implementation would allow two processes get the lock
  simultaneously:
  ++ echo 16741: /etc/xen/scripts/block
  ++ cut -d : -f 1
  + local pid=16741
  + '[' -n 16741 -a 16741 '!=' unknown -a '!' -f /proc/16741/status ']'
  + '[' 5 -gt 5 ']'
  + sleep 0
  + retries=6
  + '[' 6 -lt 100 ']'
  + mkdir /var/run/xen-hotplug/block
  ++ _lock_owner /var/run/xen-hotplug/block
  ++ cat /var/run/xen-hotplug/block/owner
  + local 'new_owner=16741: /etc/xen/scripts/block'
  + '[' '16741: /etc/xen/scripts/block' '!=' '16741: /etc/xen/scripts/block' ']'
  ++ echo 16741: /etc/xen/scripts/block
  ++ cut -d : -f 1
  + local pid=16741
  + '[' -n 16741 -a 16741 '!=' unknown -a '!' -f /proc/16741/status ']'
  + '[' 6 -gt 5 ']'
  + sleep 1
  + do_or_die losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb00001200002b0ef651033c8381.img
  + losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb00001200002b0ef651033c8381.img
  + do_or_die losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img
  + losetup -r /dev/loop27 /OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img
  + xenstore_write backend/vbd/33/51920/node /dev/loop27
  + _xenstore_write backend/vbd/33/51920/node /dev/loop27
  + log debug 'Writing backend/vbd/33/51920/node' '/dev/loop27 to xenstore.'
  + local level=debug
  + shift
  + logger -p daemon.debug -- /etc/xen/scripts/block: 'Writing backend/vbd/33/51920/node' '/dev/loop27 to xenstore.'
  ioctl: LOOP_SET_FD: Device or resource busy
  + xenstore-write backend/vbd/33/51920/node /dev/loop27
  + fatal losetup -r /dev/loop27 '/OVS/Repositories/0004fb00000300000aac184a9bbab7a9/VirtualDisks/0004fb0000120000143173990458f2a7.img failed'
  This patch removes the ownner support and fixed this issue per my test.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 14216774] 

* Thu Jun 14 2012  Dave McCracken <dave.mccracken@oracle.com> - 4.1.2-18.el5.4 
- Add restore (and migrate) functionality back in for PV superpage-enabled guests.
  Signed-off-by: Dave McCracken <dave.mccracken@oracle.com> [bug 14192660] 

* Mon Jun 11 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.3 
- x86-64: detect processors subject to AMD erratum #121 and refuse to boot{CVE-2006-0744}
  Signed-off-by: Jan Beulich <JBeulich@suse.com>
  Signed-off-by: Ian Campbell <ian.campbell@citrix.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 13993151] 

* Mon Jun 11 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.2 
- guest denial of service on syscall/sysenter exception generation {CVE-2012-0217},{CVE-2012-0218}
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 13993151] 

* Sun Jun 03 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-18.el5.1 
- Remove unecessary balloon retries on vm create.
  This is a backport from fix for bug 14143327.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Backported-by: Joe Jin <joe.jin@oracle.com> [bug 14143340] 

* Thu Mar 29 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-18 
- his patch will create a loop device node if it is not exist when VM start.
  After this patch, Kernel max_loop could be 8.
  I tested it could create 1025 loop device nodes within 1 minutes.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Adnan Misherfi <adnan.misherfi@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Mon Mar 26 2012 Joe Jin <joe.jin@oracle.com> - 4.1.2-17 
- Set max cstate to 1.
  We have several bugs that cstate made system unstable, both for ovm2 and ovm3:
  For OVM3.x:
  Bug 13703504 - unexplained network disconnect causes ocfs to fence the server
  https://forums.oracle.com/forums/thread.jspa?threadID=2347014&tstart=0
  For OVM2.x
  https://bug.oraclecorp.com/pls/bug/webbug_edit.edit_info_top?rptno=10631565
  https://bug.oraclecorp.com/pls/bug/webbug_edit.edit_info_top?rptno=13494054 [bug 13703504] 

* Mon Mar 26 2012 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.1.2-16 
- revert xen unstable changeset 22315: it breaks SSL live migration.
  Original change set:
  # HG changeset patch
  # User Miroslav Rezanina <mrezanin@redhat.com>
  # Date 1288262432 -3600
  # Node ID 31b8844fab99e0e3358e983b9a7b6617148045b3
  # Parent  28a16074681582f1209c9077f870ccf44927133e
  Do not wait for memory teardown when live migrate
  When trying to live migrate guest with great memory (e.g. 20 GB),
  there's delay caused by destroying source copy of domain.  To speed up
  this process we can close socket before starting guest destroy, as
  source guest is not running anymore.
  Signed-off-by: Miroslav Rezanina <mrezanin@redhat.com>
  Signed-off-by: Ian Jackson <ian.jackson@eu.citrix.com> [bug 13808326&13874471] 

* Sat Mar 24 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-15 
- Backport of c/s 24013 of the 32-bit compat layer, which states: "
  pvhvm running with more than 32 vcpus and pv_irq/pv_time enabled
  need vcpu placement to work, or else it will softlockup.
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Committed-by: Keir Fraser <keir@xen.org>
  "
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13073337] 

* Sat Mar 24 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-14 
- Backport of c/s 24013, which states: "
  pvhvm running with more than 32 vcpus and pv_irq/pv_time enabled
  need vcpu placement to work, or else it will softlockup.
  Signed-off-by: Zhenzhong Duan <zhenzhong.duan@oracle.com>
  Committed-by: Keir Fraser <keir@xen.org>
  "
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13073337] 

* Wed Mar 21 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-13 
- From Message-ID: <1332267691-13179-1-git-send-email-david.vrabel@citrix.com>
  If a maximum reservation for dom0 is not explictly given (i.e., no
  dom0_mem=max:MMM command line option), then set the maximum
  reservation to the initial number of pages.  This is what most people
  seem to expect when they specify dom0_mem=512M (i.e., exactly 512 MB
  and no more).
  This change means that with Linux 3.0.5 and later kernels,
  dom0_mem=512M has the same result as older, 'classic Xen' kernels. The
  older kernels used the initial number of pages to set the maximum
  number of pages and did not query the hypervisor for the maximum
  reservation.
  It is still possible to have a larger reservation by explicitly
  specifying dom0_mem=max:MMM.
  Signed-off-by: David Vrabel <david.vrabel@citrix.com>
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com>
  NOTE: This behaviour should also be implemented in the Linux kernel. [bug 13860516] 

* Wed Mar 14 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-12 
- Correct stop xend return status [bug 13845552] 

* Tue Mar 13 2012 Konrad Wilk <konrad.wilk@oracle.com> - 4.1.2-11 
- We don't support PCI segmented domains yet, so for right now
  just ignore the hypercall with that type. Dom0 is smart enough
  to fallback to the old type. If need to back-port the support
  then revisit:
  23855:e2bd50b0843a
  user:        Jan Beulich <jbeulich@suse.com>
  date:        Sun Sep 18 00:12:19 2011 +0100
  summary:     PCI multi-seg: add new physdevop-s
  changeset:   23854:e5263921c85e
  user:        Jan Beulich <jbeulich@suse.com>
  date:        Sun Sep 18 00:10:03 2011 +0100
  summary:     PCI multi-seg: introduce notion of PCI segments
  Signed-off-by: Konrad Rzeszutek Wilk <konrad.wilk@oracle.com> [bug 13727499] 

* Tue Mar 13 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-10 
- If bridge MTU != 1500, then set tap MTU to bridge MTU [bug 13773039] 

* Thu Mar 08 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-9 
- Version numbering, CVE-2012-0029 and upstream fixes
  Xen: 23263:b01091775dd9
  qemu: 3cf61880 

* Wed Feb 29 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-8 
- If needed; Change the VIF MTU before connecting it to the bridge. [bug 13773039] 

* Mon Feb 27 2012 Annie Li <annie.li@oracle.com> - 4.1.2-7 
- Fix bug 12861822(VM fails to resume automatically in WHQL test) 

* Mon Feb 27 2012 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.1.2-6 
- Put back the patch that prevent older guest that uses kudzu from hanging
  on a reboot. Fixed the patch to prevent excessive watcher writes which
  causes xend, xenstored to run at a 100%  cpu usage. Now the watch is written
  only if console in Initialising, InitWait, Initialised states which happen
  once at boot time. [bug 13523487] 

* Thu Feb 23 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-5 
- The ACPI compiler/dsdt.asl table generates nodes for S3/S4 which are
  now 12 bytes (rather than 14). Update the sizes of the chunks to be excised.
  Fixes windows boot/install and linux shutdown issues. [bug 13772650] 

* Wed Feb 22 2012 Kurt Hackel <kurt.hackel@oracle.com> - 4.1.2-4 
- set max_phys_cpus=160 [bug 13727780]

* Mon Feb 20 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-3 
- PLE can cause problems
  With PLE enabled, 2.6.32 guests will crash early on with:
  ..MP-BIOS bug: 8254 timer not connected to IO-APIC
  # a few lines omitted..
  Kernel panic - not syncing: IO-APIC + timer doesn't work!  Boot with apic=debug
  The patch to vpt.c is the suggested fix from: xiantao.zhang@intel.com.
  patch to vmcs.c was the prioir workaround. 

* Mon Feb 20 2012 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-2 
- Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Gary Grebus <gary.grebus@oracle.com> 

* Mon Dec 19 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.1.2-1
- rebase patches to 4.1.2 tree
  remove dm-nfs
  update insmod
  disable PLE temporarily
  stop building/install documentation - it can't be read on OVM server.

* Thu Sep 22 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-81 
- re-enable dm-nfs support.
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com>
  Signed-off-by: kurt.hackel@oracle.com
  Approved-by: steve.noyes@oracle.com 

* Tue Sep 06 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-80 
- Make performance the default governor like we did for 2.2.X series.
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Fri Jul 15 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-79 
- KDB: enhance dgdt. hvm set single_step. gdbsx, add trace print. 

* Fri Jul 08 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-78 
- fix solaris domU detection
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> [bug 12718579] 

* Thu Jul 07 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-77 
- tools/pygrub: fix solaris kernel sniff
  Solaris 11 build 163+ removes '/platform/i86xpv/kernel/unix' and only the
  64-bit PV kernel file '/platform/i86xpv/kernel/amd64/unix' exists.
  This patch fixes the detection.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12718579] 

* Thu Jul 07 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-76 
- tools/hotplug/Linux/block: fix shared loop device detection
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 12316734] 

* Thu Jun 16 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-75 
- AMD Bulldozer cpu's require some fixes to get them working.
  We do NOT provide the support for these features:
  - SVM perfmance enhancements ("clean bits").
  - AVX
  - LWP
  We expect Xen to be started with xsave=0 for AMD bulldozer systems in order
  to disable AVX.
  Xen-4.1-testing: 22462:98eb4a334b77
  Xen-4.1-testing: 23027:2dde81ed2e3d
  xen-unstable.hg: 23290:1ac7336b6298
  xen-unstable.hg: 23511:450f1d198e1e
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com> 

* Thu Jun 16 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-74 
- This is a Xen cumulative patch from c/s 21458 to 21511 (in the 4.0
  testing tree.) It includes an important VT-d related CVE and necessary
  updates for AMD (Bulldozer in particular).
  Signed-off-by: Andrew Thomas <andrew.thomas@oracle.com> 

* Thu Jun 09 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-73 
- fix xendomains to shutdown vms on stop
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 11907918] 

* Thu Jun 09 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-72 
- make non-ssl vnc listen on localhost only.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed Jun 08 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-71 
- KDB: Handle support for MTF flag for hvm guest single step. Set single_step in
  case of HVM guest so that MTF flag is set. 

* Mon May 23 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-70 
- enable domain lock callout.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com> 

* Mon May 23 2011 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-69 
- fix to avoid ballooning when dom0-min-mem is set and enable-dom0-ballooning
  is enabled. [bug 12404026] 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-68 
- Changes to parameters passed to ovs-agent-dlm.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-67 
- Revert to r2515. 

* Wed May 11 2011 Junjie Wei <junjie.wei@oracle.com> - 4.0.0-66 
- Change parameters passed to ovs-agent-dlm.
  Signed-off-by: Junjie Wei <junjie.wei@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Wed Apr 27 2011 Annie Li <annie.li@oracle.com> - 4.0.0-65 
- Fix Bug 10238928 - XEND CONFIG LAYER FAILS TO REFRESH GUEST DEVICE INFO WHEN CHANGED DYNAMICALLY.
  1. Add deleteDevice in XendDomainInfo.py.
  2. Call deleteDevice in deviceDestroyCallback of DevController.py.
  3. set event after wait timeout. 

* Thu Mar 24 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-64 
- KDB: print longs for page struct fields. 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-63 
- Add -OVM to version information. This is visible through smbios/dmidecode
  information for HVM (ie Solaris) guests. [bug 11792774] 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-62 
- Important security fix.
  # HG changeset patch
  # User Tim Deegan <Tim.Deegan@citrix.com>
  # Date 1300122058 0
  # Node ID ee088a0b5cb89793da67abb3cc389f42247bba98
  # Parent  b024d5ecc1943c0d74bfc04cb440ea96159e429b
  x86_64: fix error checking in arch_set_info_guest()
  Cannot specify user mode execution without specifying user-mode
  pagetables.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com>
  Acked-by: Keir Fraser <keir@xen.org>
  xen-unstable changeset:   23034:c79aae866ad8
  xen-unstable date:        Mon Mar 14 16:59:49 2011 +0000 

* Fri Mar 18 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-61 
- Cumulative updates from upstream (mostly HVM related).
  Changesets 21423-21457 [inclusive, but removing mercurial repo changes.]
  Includes 21440 which addresses Orabug: 10255006 [bug 10255006] 

* Fri Mar 04 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-60 
- xmstat: fix type in README. 

* Tue Feb 22 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-59 
- KDB: clear watchpoints on all cpus. 

* Mon Feb 21 2011 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.0.0-58 
- When a VIF connect to a bridge change its MTU (1500 | 9000) if needed. 

* Fri Feb 18 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-57 
- KDB: Do detailed display of VMCS on Intel upon dvmc cmd. 

* Fri Feb 18 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-56 
- KDB: enhance dgdt again. check for valid mfn in m2p command. 

* Thu Feb 10 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-55 
- A hack to disable dm-nfs support prioir to Junjie's clean up.
  Signed-off-by: kurt.hackel@oracle.com :-) 

* Thu Feb 03 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-54 
- KDB: refresh disassembler library, udis, to 1.7. 

* Thu Feb 03 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-53 
- KDB: changes related to refreshing upstream ext tree to latest unstable" 

* Mon Jan 31 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-52 
- Import 2.2 patch for Solaris PXE boot. Also update eb-roms.h file to
  prebuilt version (a minor annoyance with srpm repos). [bug 11076422&10135669] 

* Tue Jan 25 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-51 
- gdbsx: update README. kdb: update README with btp cmd. xmstat: Update tools/Makefile and add perf/Makefile to always build and install it. 

* Fri Jan 21 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-50 
- KDB: add new cmd btp, to trace upon breakpoints. Add display of timer structs
  and vlapic structs. 

* Thu Jan 20 2011 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-49 
- XMSTAT: initial checkin. 

* Tue Jan 04 2011 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-48
- Cumulative patch from 21327 to 21422; as we already had some of these
  applied, this cumulative patch omits: 21336, 21337, 21344.
  This patch contains some minor changes for IDLE_DOMAIN_ID to
  DOMID_IDLE changes affecting:
  kdb_cmds.c
  x86/udis86-1.6/kdb_dis.c 

* Mon Dec 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-47 
- Fix xend service stop status: return 0 on success.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Acked-by: Kurt Hackel <kurt.hackel@oracle.com> [bug 10334816] 

* Tue Nov 16 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-46 
- Add dependency on pciutils-devel for xen-tools package

* Tue Nov 16 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-45 
- KDB: Redo gdt display command. Add commands to display MSRs and cpuid outputs. 

* Thu Oct 07 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-44
- Remove SDL-devel, gtk2-devel, and libX11-devel from BuildRequires

* Wed Oct 06 2010 Adnan Misherfi <adnan.misherfi@oracle.com> - 4.0.0-43 
- Fix a descriptor leak in xenstore. The function xs_daemon_close() was not closing descriptors.
  orabug:10155532 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-42 
- Add rule to create /dev/xen/gntdev 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-41 
- Disable ballooning of dom0 - this is from 2.2.1 (see bug 8604766
  and 9485681). Not an orabug on this release though. 

* Tue Oct 05 2010 Andrew Thomas <andrew.thomas@oracle.com> - 4.0.0-40 
- 2.6.32 kernel uses gntdev as a module, so load it at runtime 

* Fri Sep 10 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-39 
- x2apic related fixes from Yinghai Lu. Increase MAX_LOCAL_APIC to 512, change apic_id to u32, etc... 

* Tue Sep 07 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-38 
- Disable intel xsave. Changeset 21336 in unstable. See http://www.gossamer-threads.com/lists/xen/devel/184099, or search xen devel archives for "xen trouble while guest excute float app". 

* Tue Sep 07 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-37 
- gdbsx: Try the MTF flag first during HVM guest single step, reverting to
  manually setting the TF flag if that fails. 

* Thu Sep 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-36 
- Apply patches from Yinghai: mparse_pass_32bit_apicid, 256_cpus, x2apic_preenable, x2apic-acpi, and remove_warning.patch. 

* Sun Aug 29 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-35 
- Stage qemu-dm in /usr/lib64 

* Thu Aug 26 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-34 
- Refresh xen to xen RELEASE-4.0.1, C/S 21326. Refresh QEMU to TAG xen-4.0.1. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-33 
- xend: acpi s3/s4 code clean up. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-32 
- Backport xen unstable cs 21839:
  hvmloader: clear the whole shared-info page when shutting down xenbus
  since the contents might be in the wrong word-size for later users.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-31 
- xend: add acpi s3/s4 configuration options. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-30 
- hvmloader: enable dynamic acpi s3/s4 change. 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-29 
- Backport xen-unstable-cs-21831:
  hvmloader: clear the xenbus event-channel when we're done with it.
  Otherwise a later xenbus client that naively waits for the rising edge
  could get stuck.
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Mon Jul 26 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-28 
- Backport xen-unstable-cs-21767:
  hvmloader: Add a xenbus frontend so it can read values from xenstore
  Signed-off-by: Tim Deegan <Tim.Deegan@citrix.com> 

* Fri Jul 16 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-27 
- display more cpu data info. sync with ext tree c/s 20376, unst c/s 21811. 

* Thu Jul 15 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-26 
- Make gdbsx part of normal xen to align with upstream. 

* Thu Jul 15 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-25 
- Remove space from qThreadInfo packet because newer gdb version 7* has
  a bug in parsing thread list. Also, another gdb bug in printf. 

* Fri Jul 09 2010 Srinivas Maturi <srinivas.maturi@oracle.com> - 4.0.0-24 
- Stage hvmloader and qemu-dm in /usr/lib and /usr/lib64 for backward
  compatibility with vm.cfg files from OVM 2.x [bug 9348075] 

* Thu Jul 08 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-23 
- back port xen-unstable change set 21684:
  tools/python: sxp parser: show empty string
  This patch makes the sxp parser show empty string.
  Test case:
  import sxp
  sxp.show(sxp.from_string('(a "")'))
  sxp.show(sxp.from_string("(a '')"))
  Without this patch:
  (a )(a )
  With this patch:
  (a '')(a '')
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com> 

* Thu Jul 08 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-22 
- Improve xend service to give better status report. [bug 9882998] 

* Tue Jun 29 2010 Dan Magenheimer <dan.magenheimer@oracle.com> - 4.0.0-21 
- tmem page dedup and tmem bug fixes through xen-unstable cs21658 

* Fri Jun 25 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-20 
- Add ext4 support for pygrub: use the shipped ext2 library. 

* Fri Jun 18 2010 Kevin Lyons <kevin.x.lyons@oracle.com> - 4.0.0-19 
- Alter xen/Makefile to install the debug hypervisor when built with the gdbsx flag.
  Oracle-bug:9817500 

* Wed Jun 09 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-18 
- KDB: Add new cmd to display loaded modules in a guest. Add barrier() in
  kdb_trap_immed(). 

* Tue May 25 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-17 
- 1) NEW: conditional breakpoints.  2) Redo dirq cmd.  3) NEW: cmd dvit (display per cpu vector irq table).

* Mon May 17 2010 Gary Grebus <gary.grebus@oracle.com> - 4.0.0-16 
- Add workarounds for timer interrupt routing crashes on some Supermicro systems.
  The MP BIOS tables on some systems incorrectly route the timer interrupt.
  Try to automatically set the kernel parameter "acpi_skip_timer_override" on
  these systems.  Add kernel parameter "acpi_use_timer_override" to disable
  automatic application.
  Signed-off-by: kurt.hackel@oracle.com [bug 9694370] 

* Sun May 16 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-15 
- expose host uuid to guest via xenstore.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed May 12 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-14 
- Set VM vnc server listen everywhere.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Wed May 12 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-13 
- Enables xend ssl relocation server.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com> 

* Sun May 09 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-12 
- Enable dm-nfs block setup.
  Signed-off-by: Zhigang Wang <zhigang.x.wang@oracle.com>
  Signed-off-by: Kurt Hackel <kurt.hackel@oracle.com>
  Signed-off-by: Gary Grebus <gary.grebus@oracle.com> 

* Wed May 05 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-11 
- disable network-script 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-10 
- Load backend modules at xend start. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-9 
- Put xenstored tdb to tmpfs. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-8 
- Add long cmdline support. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-7 
- Add domain running lock callout hook. 

* Tue Apr 06 2010 Zhigang Wang <zhigang.x.wang@oracle.com> - 4.0.0-6 
- Add vbd/vif qos support. 

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-5 
- Enable building of debug pkgs.

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-4 
- DEBUG PKG: Enable build of gdbsx so it can be included in our debug pkg. 

* Fri Apr 02 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-3 
- KDB: merge kdb patch. 

* Wed Apr 01 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-2
- Add dummy-null.patch so the autopatch can be turned on. The autopatch will
  fail if there are no patches in the spec file.

* Wed Apr 01 2010 Mukesh Rathor <mukesh.rathor@oracle.com> - 4.0.0-1
- Initial spec file for xen 4.0 in ovm3.0 release. The initial tar file 
  for Source0 is tar of the base expanded tree. Basically, xen 4.0 c/s 21088
  with qemu copied locally, and iasl compiled and put in the acpi directory.
  
